Option Explicit ' Jede verwendete Variable muss deklariert sein

Begin Dialog KALENDER 147, 47, 149, 75, "Kalender"
	Text 12, 8, 124, 12, "Fr welches Jahr soll der Kalender erzeugt werden?"
	TextBox 12, 20, 48, 10, .Year
	OptionGroup .holidays
		OptionButton 12, 32, 84, 12, "Kalender mit Feiertagen"
		OptionButton 12, 40, 84, 12, "Kalender ohne Feiertage"
	OKButton 20, 60, 48, 12
	CancelButton 76, 60, 48, 12
End Dialog

Dim pm As Object                   ' PlanMaker-Objekt
Dim vDays(7) As String             ' Wochennamen
Dim vMonthDay(1 To 12) As Integer  ' Anzahl Tage pro Monat
Dim GetYear As KALENDER            ' Dialog
Dim UseHolidays As Integer         ' Sollen Feiertage eingetragen werden?
Dim CalYear As Integer             ' Gewnschtes Kalenderjahr
Dim HolidayEaster As Integer       ' Ostersonntag: x-ter Tag im Jahr
Dim HolidayChristmas As Integer    ' 4. Advent: x-ter Tag im Jahr
Dim HolidaySummer As Integer       ' Beginn der Sommerzeit
Dim HolidayWinter As Integer       ' Ende der Sommerzeit
Dim HolidayMothersDay As Integer   ' Muttertag

Sub Main
   Dim vMonths(1 To 12) As String  ' Monatsnamen
   Dim Cell As String              ' Aktuelle Zelle
   Dim Start As String             ' Startzelle eines Monats
   Dim CalWeekDay As Integer       ' Fortlaufender Wochentag
   Dim CalMonth As Integer         ' Schleifenvariable fr Monate
   Dim LeapYear As Integer         ' Ist das Jahr ein Schaltjahr?
   Dim CalNumberDay As Integer     ' Fortlaufender Tag
   Dim CurRange As Object
 
	' Arrays initialisieren
 
	vDays(0) = "So"
	vDays(1) = "Mo"
	vDays(2) = "Di"
	vDays(3) = "Mi"
	vDays(4) = "Do"
	vDays(5) = "Fr"
	vDays(6) = "Sa"
	
	vMonths(1) = "Januar"
	vMonths(2) = "Februar"
	vMonths(3) = "Mrz"
	vMonths(4) = "April"
	vMonths(5) = "Mai"
	vMonths(6) = "Juni"
	vMonths(7) = "Juli"
	vMonths(8) = "August"
	vMonths(9) = "September"
	vMonths(10) = "Oktober"
	vMonths(11) = "November"
	vMonths(12) = "Dezember"

	vMonthDay(1) = 31
	vMonthDay(2) = 28
	vMonthDay(3) = 31
	vMonthDay(4) = 30
	vMonthDay(5) = 31
	vMonthDay(6) = 30
	vMonthDay(7) = 31
	vMonthDay(8) = 31
	vMonthDay(9) = 30
	vMonthDay(10) = 31
	vMonthDay(11) = 30
	vMonthDay(12) = 31

	' Defaultwerte fr den Dialog festlegen
	GetYear.Year = year(now())	'2013
	GetYear.Holidays = 0

	' Dialog aufrufen
	If Dialog(GetYear) = 0 Then Exit Sub

	CalYear = GetYear.Year
	UseHolidays = GetYear.Holidays
 
	' Startzelle
	Cell = "A2"

	' Erster Wochentag des Jahres
	CalWeekDay = Weekday("01.01." + Str(CalYear)) - 1

	' Fortlaufender Tag im Jahr
	CalNumberDay = 1

	' Ist das Jahr ein Schaltjahr?
	If (CalYear Mod 4 = 0) And (CalYear Mod 100 <> 0) Then
		LeapYear = 1
	Else 
		LeapYear = 0
	End If
 
	If CalYear Mod 400 = 0 Then LeapYear = 1

	vMonthDay(2) = 28 + LeapYear

	' Den Ostersonntag als Tag im Jahr ermitteln
	HolidayEaster = GetHolidayEaster(CalYear, LeapYear)

	' Den 4. Advent als Tag im Jahr ermitteln
	HolidayChristmas = 359 + LeapYear - Weekday("24.12." + Str(CalYear))

	' Den Muttertag als Tag im Jahr ermitteln
	HolidayMothersDay = 135 + LeapYear - Weekday("30.04." + Str(CalYear))
	If HolidayMothersDay = HolidayEaster + 49 Then ' Muttertag <> Pfingstsonntag
		HolidayMothersDay = HolidayMothersDay - 7
	End If

	' PlanMaker starten
	Set pm = CreateObject("PlanMaker.Application")

	' Erstelle neues Dokument
	pm.Visible = True
	pm.Activate
	pm.Workbooks.Add

	' Automatikfunktionen abschalten, um die Ablaufgeschwindigkeit zu erhhen
	pm.ActiveWorkbook.Calculation = pmCalculationManual
	pm.ActiveWindow.DisplayGridlines = False
	pm.ActiveWorkbook.ScreenUpdate = False
	pm.ActiveWorkbook.ManualApply = True

	' berschrift
	Set CurRange = pm.Range("A1")
	CurRange.Value = "Kalender " + Str(CalYear)
	CurRange.Font.Bold = True
	CurRange.Font.Size = 28
	CurRange.Font.Name = "Arial"
	CurRange.ApplyFormatting

	For CalMonth = 1 To 12
		Start = Cell

		' Monat ausfllen         
		FillMonth Cell, CalWeekDay, CalMonth, CalNumberDay

		' Monatsname
		Set CurRange = pm.Range(Cell)
		CurRange.Value = vMonths(CalMonth)        
		pm.Columns(CurRange.Column).ColumnWidth = 20

		Cell = NextCol(Cell)

		Set CurRange = pm.Range(Cell)
		pm.Columns(CurRange.Column).ColumnWidth = 18

		Cell = NextCol(Cell)

		Set CurRange = pm.Range(Cell)
		pm.Columns(CurRange.Column).ColumnWidth = 80

		' Formatiere Monatsnamen                                          
		Set CurRange = pm.Range(Start + ":" + Cell)

		CurRange.Font.Bold = True
		CurRange.Font.Size = 9
		CurRange.Font.Name = "Arial"

		CurRange.Shading.ForegroundPatternColor = pmColorCyan
		CurRange.Shading.Intensity = 30

		CurRange.Borders(pmBorderLeft).Type = 1
		CurRange.Borders(pmBorderLeft).Thick1 = 1

		CurRange.Borders(pmBorderTop).Type = 1
		CurRange.Borders(pmBorderTop).Thick1 = 1

		CurRange.Borders(pmBorderRight).Type = 1
		CurRange.Borders(pmBorderRight).Thick1 = 1

		CurRange.Borders(pmBorderBottom).Type = 1
		CurRange.Borders(pmBorderBottom).Thick1 = 1

		CurRange.LeftPadding = 4
		CurRange.ApplyFormatting

		Cell = NextCol(Cell)
	Next CalMonth

	If UseHolidays = 0 Then
		Set CurRange = pm.Range("A35")
		CurRange.Value = "* Feiertag in einigen Bundeslndern"
		CurRange.Font.Size = 8
		CurRange.ApplyFormatting
	End If

	Set CurRange = pm.Range("A37")
	CurRange.Value = "Alle Angaben ohne Gewhr"
	CurRange.Font.Size = 8
	CurRange.ApplyFormatting

	pm.Range("A1").Select

	' Bildschirmaktualisierung wieder einschalten
	pm.ActiveWorkbook.Calculation = pmCalculationAutomatic
	pm.ActiveWorkbook.ScreenUpdate = True
End Sub

' Ostersonntag bestimmen

Function GetHolidayEaster(CYear As Integer, LeapYear As Integer) As Integer
	Dim gz As Integer
	Dim jhd As Integer
	Dim ksj As Integer
	Dim korr As Integer
	Dim so As Integer
	Dim epakte As Integer
	Dim n As Integer

	gz = (CYear Mod 19) + 1
	jhd = Int(CYear / 100) + 1
	ksj = Int((3 * jhd) / 4) - 12
	korr = Int((8 * jhd + 5) / 25) - 5
	so = int((5 * CYear) / 4) - ksj - 10
	epakte = (11 * gz + 20 + korr - ksj) Mod 30
	If (epakte = 25 And gz > 11) Or epakte = 24 Then epakte = epakte + 1
	n = 44 - epakte
	If n < 21 Then n = n + 30 
	n = n + 7 - (so + n) Mod 7

	GetHolidayEaster = n + LeapYear + 59
End Function

' Feiertage in den Kalender eintragen

Function IsHoliday(Cell1 As String, Cell2 As String, CMonthDay As Integer, CMonth As Integer, NumberDay As Integer) As Integer
	IsHoliday = 0

	Select Case NumberDay
		Case HolidayEaster - 48
			pm.Range(Cell2).Value = "Rosenmontag"
			IsHoliday = 0
		Case HolidayEaster - 46
			pm.Range(Cell2).Value = "Aschermittwoch"
			IsHoliday = 0
		Case HolidayEaster - 3
			pm.Range(Cell2).Value = "Grndonnerstag"
			IsHoliday = 0
		Case HolidayEaster - 2
			pm.Range(Cell2).Value = "Karfreitag"
			IsHoliday = 1
		Case HolidayEaster
			pm.Range(Cell2).Value = "Ostersonntag"
			IsHoliday = 1
		Case HolidayEaster + 1
			pm.Range(Cell2).Value = "Ostermontag"
			IsHoliday = 1
		Case HolidayEaster + 39
			pm.Range(Cell2).Value = "Christi Himmelfahrt"
			IsHoliday = 1
		Case HolidayEaster + 49
			pm.Range(Cell2).Value = "Pfingstsonntag"
			IsHoliday = 1
		Case HolidayEaster + 50
			pm.Range(Cell2).Value = "Pfingstmontag"
			IsHoliday = 1
		Case HolidayEaster + 60
			pm.Range(Cell2).Value = "Fronleichnam*"
			IsHoliday = 2
		Case HolidayChristmas - 35
			pm.Range(Cell2).Value = "Volkstrauertag"
			IsHoliday = 1
		Case HolidayChristmas - 32
			pm.Range(Cell2).Value = "Bu- und Bettag*"
			IsHoliday = 2
		Case HolidayChristmas - 28
			pm.Range(Cell2).Value = "Totensonntag"
			IsHoliday = 1
		Case HolidayChristmas - 21
			pm.Range(Cell2).Value = "1. Advent"
			IsHoliday = 0
		Case HolidayChristmas - 14
			pm.Range(Cell2).Value = "2. Advent"
			IsHoliday = 0
		Case HolidayChristmas - 7
			pm.Range(Cell2).Value = "3. Advent"
			IsHoliday = 0
		Case HolidayChristmas
			pm.Range(Cell2).Value = "4. Advent"
			IsHoliday = 0
		Case HolidayMothersDay
			pm.Range(Cell2).Value = "Muttertag"
			IsHoliday = 1
		Case Else
	End Select

	If CMonth = 3 And CMonthDay > 24 Then
		If WeekDay(Str(CMonthDay) + ".03." + Str(CalYear)) = 1 Then
			pm.Range(Cell2).Value = "Beginn Sommerzeit"
			IsHoliday = 0
		End If
	End If

	If CMonth = 10 And CMonthDay > 24 Then
		If WeekDay(Str(CMonthDay) + ".10." + Str(CalYear)) = 1 Then
			pm.Range(Cell2).Value = "Ende Sommerzeit"
			IsHoliday = 0
		End If
	End If

	If CMonth = 10 And CMonthDay < 8 Then
		If WeekDay(Str(CMonthDay) + ".10." + Str(CalYear)) = 1 Then
			pm.Range(Cell2).Value = "Erntedankfest"
			IsHoliday = 1
		End If
	End If

	If CMonth = 1 And CMonthDay = 1 Then
		pm.Range(Cell2).Value = "Neujahr"
		IsHoliday = 1
	End If

	If CMonth = 1 And CMonthDay = 6 Then
		pm.Range(Cell2).Value = "Heilige drei Knige*"
		IsHoliday = 2
	End If

	If CMonth = 5 And CMonthDay = 1 Then
		pm.Range(Cell2).Value = "Maifeiertag"
		IsHoliday = 1
	End If

	If CMonth = 8 And CMonthDay = 15 Then
		pm.Range(Cell2).Value = "Mari Himmelfahrt*"
		IsHoliday = 2
	End If

	If CMonth = 10 And CMonthDay = 3 Then
		pm.Range(Cell2).Value = "Tag der dt. Einheit"
		IsHoliday = 1
	End If

	If CMonth = 10 And CMonthDay = 31 Then
		pm.Range(Cell2).Value = "Reformationstag*"
		IsHoliday = 2
	End If

	If CMonth = 11 And CMonthDay = 1 Then
		pm.Range(Cell2).Value = "Allerheiligen*"
		IsHoliday = 2
	End If

	If CMonth = 12 And CMonthDay = 6 Then
		pm.Range(Cell2).Value = "Nikolaus"
		IsHoliday = 0
	End If

	If CMonth = 12 And CMonthDay = 24 Then
		pm.Range(Cell2).Value = "Heiligabend"
		IsHoliday = 0
	End If

	If CMonth = 12 And CMonthDay = 25 Then
		pm.Range(Cell2).Value = "1. Weihnachtstag"
		IsHoliday = 1
	End If

	If CMonth = 12 And CMonthDay = 26 Then
		pm.Range(Cell2).Value = "2. Weihnachtstag"
		IsHoliday = 1
	End If

	If CMonth = 12 And CMonthDay = 31 Then
		pm.Range(Cell2).Value = "Silvester"
		IsHoliday = 0
	End If

	If IsHoliday = 1 Then
		Set CurRange = pm.Range(Cell1 + ":" + Cell2)
		CurRange.Shading.ForegroundPatternColor = pmColorYellow
		CurRange.Shading.Intensity = 30
		CurRange.ApplyFormatting
	ElseIf IsHoliday = 2 Then
		Set CurRange = pm.Range(Cell1 + ":" + NextCol(Cell1))
		CurRange.Shading.ForegroundPatternColor = pmColorYellow
		CurRange.Shading.Intensity = 30
		CurRange.ApplyFormatting
	End If
End Function

' Die Zellen fr einen kompletten Monat erzeugen

Sub FillMonth(StartCell As String, CDay As Integer, CMonth As Integer, NumberDay As Integer)
	Dim ColCell As String
	Dim RowCell As String
	Dim dstart As String
	Dim Cell2 As String
	Dim MonthDay As Integer
	Dim DrawWeekend As Integer

	RowCell = StartCell

	For MonthDay = 1 To vMonthDay(CMonth)
		ColCell = NextRow(RowCell)
		RowCell = ColCell

		DStart = ColCell

		' Wochentag eintragen
		pm.Range(ColCell).value = vDays(cDay)
		ColCell = NextCol(ColCell)
		Cell2 = ColCell

		' Tag des Monats
		pm.Range(ColCell).value = Str(MonthDay)
		ColCell = NextCol(ColCell)

		DrawWeekEnd = 1

		If UseHolidays = 0 Then ' Feiertage eintragen?
			If IsHoliday(DStart, ColCell, MonthDay, CMonth, NumberDay) > 0 Then DrawWeekEnd = 0
		End If

		If DrawWeekend Then
			If cDay = 6 Then
				Set CurRange = pm.Range(DStart)
				CurRange.Shading.ForegroundPatternColor = pmColorGreen
				CurRange.Shading.Intensity = 30
				CurRange.ApplyFormatting
			ElseIf cDay = 0 Then
				Set CurRange = pm.Range(DStart + ":" + ColCell)
				CurRange.Shading.ForegroundPatternColor = pmColorGreen
				CurRange.Shading.Intensity = 30
				CurRange.ApplyFormatting
			End If
		End If

		cDay = cDay + 1
		If cDay > 6 Then cDay = 0
		NumberDay = NumberDay + 1
	Next

	RowCell = NextRow(StartCell)

	' Umrandung des Wochentags

	Set CurRange = pm.Range(RowCell + ":" + Cell2)
	CurRange.Font.Size = 8
	CurRange.Font.Name = "Arial"
	CurRange.Borders(pmBorderLeft).Type = 1
	CurRange.Borders(pmBorderLeft).Thick1 = 1
	CurRange.Borders(pmBorderTop).Type = 1
	CurRange.Borders(pmBorderTop).Thick1 = 1
	CurRange.Borders(pmBorderRight).Type = 1
	CurRange.Borders(pmBorderRight).Thick1 = 1
	CurRange.Borders(pmBorderBottom).Type = 1
	CurRange.Borders(pmBorderBottom).Thick1 = 1
	CurRange.Borders(pmBorderHorizontal).Type = 1
	CurRange.Borders(pmBorderHorizontal).Thick1 = 1
	CurRange.LeftPadding = 4
	CurRange.ApplyFormatting

	' Umrandung der Beschreibung des Wochentags

	RowCell = NextCol(RowCell)
	RowCell = NextCol(RowCell)
	Set CurRange = pm.Range(RowCell + ":" + ColCell)
	CurRange.Font.Size = 8
	CurRange.Font.Name = "Arial"
	CurRange.Borders(pmBorderLeft).Type = 1
	CurRange.Borders(pmBorderLeft).Thick1 = 1
	CurRange.Borders(pmBorderTop).Type = 1
	CurRange.Borders(pmBorderTop).Thick1 = 1
	CurRange.Borders(pmBorderRight).Type = 1
	CurRange.Borders(pmBorderRight).Thick1 = 1
	CurRange.Borders(pmBorderBottom).Type = 1
	CurRange.Borders(pmBorderBottom).Thick1 = 1
	CurRange.Borders(pmBorderHorizontal).Type = 1
	CurRange.Borders(pmBorderHorizontal).Thick1 = 1
	CurRange.LeftPadding = 4
	CurRange.ApplyFormatting
End Sub

' Gibt bei bergabe einer Zelladresse die Adresse der Zelle in der nchsten Zeile zurck

Function NextRow(cell As String) As String
	Dim letters As Integer

	If InStr(1, "ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(cell, 2, 1)) Then
		letters = 2
	Else
		letters = 1
	End If

	If letters = 2 Then
		NextRow = Left(cell, 2) + Str(Val(Mid(cell, 3, 8)) + 1)
	Else
		NextRow = Left(cell, 1) + Str(Val(Mid(cell, 2, 8)) + 1)
	End If
End Function

' Gibt bei bergabe einer Zelladresse die Adresse der Zelle in der nchsten Spalte zurck

Function NextCol(cell As String) As String
	Dim letters As Integer

	If InStr(1, "ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(cell, 2, 1)) Then 
		letters = 2 
	Else
		letters = 1
	End If

	If Mid(cell, letters, 1) = "Z" Then
		If letters = 2 Then ' AZ1 -> BA1
			NextCol = Chr(Asc(Left(cell, 1)) + 1) + "A" + Mid(cell, 3, 8)
		Else ' Z1 -> AA1
			NextCol = "AA" + Mid(cell, 2, 8)
		End If
	Else
		If letters = 2 Then ' AA1 -> AB1
			NextCol = Left(cell, 1) + Chr(Asc(Mid(cell, 2, 1)) + 1) + Mid(cell, 3, 8)
		Else ' A1 -> B1
			NextCol = Chr(Asc(Left(cell, 1)) + 1) + Mid(cell, 2, 8)
		End If
	End If
End Function
