﻿Option Explicit

Sub TextMakerMultiPrinter
	Dim fullName as string
	Dim elements as integer
	Dim counter1 as string
	Dim counter2 as string
	Dim i as integer
	Dim j as integer
	Dim cr as string

	Dim max_files as integer

	' Maximale Zahl der Dateien, die ausgedruckt werden können

	max_files = 1000
	Dim ListBoxElements$(1000)


	' Dialog zur Festlegung des Dateinamen-Systems
	Begin Dialog FileNameDlg 92,117, 277, 75, "Dateiname"
	   Text 5,6,67,8, "Dateiname:"
   	TextBox 4,24,88,12, .FileName
	   Text 95,26,8,10, "+"
   	Text 105,6,35,8, "von/bis:"
	   TextBox 105,18,23,12, .Count1_Start
   	TextBox 105,32,23,12, .Count1_End
	   Text 132,26,8,12, "+"
   	TextBox 140,24,25,12, .Sep1
	   Text 169,26,7,9, "+"
   	Text 178,6,35,10, "von/bis:"
	   TextBox 178,18,24,12, .Count2_Start
	   TextBox 178,32,24,12, .Count2_End
   	Text 206,26,8,12, "+"
	   TextBox 216,24,26,12, .Sep2
   	Text 243,26,4,12, "."
	   Text 247,6,20,8, "Typ:"
   	TextBox 248,24,20,12, .FileType
	   OKButton 178,55,40,12
   	CancelButton 224,55,44,12
	End Dialog

	' Dialog mit einer Liste aller erzeugten Dateinamen

	Begin Dialog FileListDlg 147,49, 200, 136, "Drucken"
   	GroupBox 4,4,187,92, "Dateien"
	   ListBox 8,12,177,88, ListBoxElements(), .ListBox_1
   	Text 4,101,188,12, "Wollen Sie diese Dateien jetzt ausdrucken?"  
	   OKButton 86,117,50,12
	   CancelButton 142,117,50,12
	End Dialog

	Dim Dlg As FileNameDlg
	Dim Dlg2 As FileListDlg

	' Willkommensmeldungen

	cr = Chr(13) + chr(10)

	MsgBox	"Dieses Programm druckt auf einen Schlag eine Reihe von TextMaker-Dateien aus, die einem" + cr + _
				"gewissen Nummerierungsschema gehorchen." + cr + cr + _
				"Sie können bis zu zwei verschachtelte Nummernkreise sowie Anfangs-, Mittel-" + cr + _
				"und Endbuchstaben Ihres Systems zur Vergabe von Dateinamen angeben." + cr + cr + _
				"Einige Anwendungsbeispiele werden auf der nächsten Seite angezeigt."

	MsgBox	"Beispiele:" + cr + cr + _
				"Dateien 1.tmd bis 9.tmd ausdrucken:" + cr + _
				"- 'von': 1" + cr + _
				"- 'bis': 9" + cr + _
				"- alle anderen Felder leerlassen" + cr + cr + _
				"Dateien BRIEF1.tmd bis BRIEF5.tmd ausdrucken:" + cr + _
				"- 'Dateiname': BRIEF" + cr + _
				"- 'von': 1" + cr + _
				"- 'bis': 5" + cr + _
				"- alle anderen Felder leerlassen" + cr + cr + _
				"Dateien c:\Dokumente\BRIEF-2007~01.tmd bis c:\Dokumente\BRIEF-2008~40.tmd ausdrucken:" + cr + _
				"- 'Dateiname': c:\Dokumente\BRIEF-" + cr + _
				"- Erstes 'von': 2007" + cr + _
				"- Erstes 'bis': 2008" + cr + _
				"- Trenner: ~" + cr + _
				"- Zweites 'von': 01" + cr + _
				"- Zweites 'bis': 40"

	' Dialoge vorbefüllen

	Dlg.FileType = "tmd"

	If Dialog(Dlg) = 0 Then Exit Sub

	' Die Liste der Dateinamen erzeugen

	elements = 0

	For i = Val(Dlg.Count1_Start) to Val(Dlg.Count1_End)
	   For j = Val(Dlg.Count2_Start) to Val(Dlg.Count2_End)

   	   ' Text für den ersten Zähler
      	If Val(Dlg.Count1_Start) = 0 and Val(Dlg.Count1_End) = 0 Then
	         counter1 = ""
   	   else
      	   counter1 = Str(i)
         
	         ' Dem ersten Zähler führende Nullen hinzufügen
   	      If (Len(Dlg.Count1_End) - Len(counter1)) > 0 Then
      	      counter1 = String(Len(Dlg.Count1_End) - Len(counter1), "0") + counter1
         	End If
	      End If

   	   ' Text für den zweiten Zähler
      	If Val(Dlg.Count2_Start) = 0 and Val(Dlg.Count2_End) = 0 Then
         	counter2 = ""
	      else
   	      counter2 = Str(j)
         
	         ' Dem zweiten Zähler führende Nullen hinzufügen
   	      If (Len(Dlg.Count2_End) - Len(counter2)) > 0 Then
      	      counter2 = String(Len(Dlg.Count2_End) - Len(counter2), "0") + counter2
         	End If
	      End If

   	   ' Kompletten Namen erzeugen
      	fullName = Dlg.FileName + counter1 + Dlg.Sep1 + counter2 + Dlg.Sep2 + "." + Dlg.FileType

	      ' Den Namen in der Listbox eintragen
   	   ListBoxElements(elements) = fullName
      
      	If elements < max_files Then
	         elements = elements + 1
   	   Else
      	    Exit For
	      End If
   
	   Next
	Next

	' Liste der generierten Dateinamen anzeigen

	If Dialog(Dlg2) = 0 Then Exit Sub

	Set sm = CreateObject("TextMaker.Application")
	sm.activate
	sm.visible = TRUE
        
	' Die Dateien der Reihe nach von TextMaker ausdrucken lassen

	For i = 0 to elements - 1
   	fullName = ListBoxElements(i)
   
	   If Len(fullName) > 0 Then
      	sm.Documents.Open fullName
	      sm.ActiveDocument.PrintOut
   	   sm.ActiveDocument.Close
	   End If
	Next

	' TextMaker beenden

	sm.Quit
	Set sm = Nothing
End Sub

