﻿Option Explicit

Sub TextMakerMultiPrinter
	Dim fullName as string
	Dim elements as integer
	Dim counter1 as string
	Dim counter2 as string
	Dim i as integer
	Dim j as integer
	Dim cr as string

	Dim max_files as integer

	' Set maximum number of files to print

	max_files = 1000
	Dim ListBoxElements$(1000)

	' Dialog to set pattern for filenames

	Begin Dialog FileNameDlg 92,117, 277, 75, "File name"
	   Text 5,6,67,8, "Dateiname:"
   	TextBox 4,24,88,12, .FileName
	   Text 95,26,8,10, "+"
   	Text 105,6,35,8, "from/to:"
	   TextBox 105,18,23,12, .Count1_Start
   	TextBox 105,32,23,12, .Count1_End
	   Text 132,26,8,12, "+"
   	TextBox 140,24,25,12, .Sep1
	   Text 169,26,7,9, "+"
   	Text 178,6,35,10, "from/to:"
	   TextBox 178,18,24,12, .Count2_Start
	   TextBox 178,32,24,12, .Count2_End
   	Text 206,26,8,12, "+"
	   TextBox 216,24,26,12, .Sep2
   	Text 243,26,4,12, "."
	   Text 247,6,20,8, "Type:"
   	TextBox 248,24,20,12, .FileType
	   OKButton 178,55,40,12
   	CancelButton 224,55,44,12
	End Dialog

	' Dialog with a list of all generated filenames

	Begin Dialog FileListDlg 147,49, 200, 136, "Print"
   	GroupBox 4,4,187,92, "Files"
	   ListBox 8,12,177,88, ListBoxElements(), .ListBox_1
   	Text 4,101,188,12, "Do you really want to print these files?"
	   OKButton 86,117,50,12
	   CancelButton 142,117,50,12
	End Dialog

	Dim Dlg As FileNameDlg
	Dim Dlg2 As FileListDlg

	' welcome
	cr = Chr(13) + chr(10)

	MsgBox	"This program prints, one after another, a collection of TextMaker files that follow a certain" + cr + _
				"numbering scheme." + cr + cr + _
				"You can define up to two nested numbering ranges and also enter initial, middle, and ending letters." + cr + cr + _
				"Some usage samples will be shown on the next screen."

	MsgBox	"Examples:" + cr + cr + _
				"Print files 1.tmd to 9.tmd:" + cr + _
				"- 'from': 1" + cr + _
				"- 'to': 9" + cr + _
				"- leave everything else empty" + cr + cr + _
				"Print files LETTER1.tmd to LETTER5.tmd:" + cr + _
				"- 'File name': LETTER" + cr + _
				"- 'from': 1" + cr + _
				"- 'to': 5" + cr + _
				"- leave everything else empty" + cr + cr + _
				"Print files c:\Documents\LETTER-2007~01.tmd to c:\Documents\LETTER-2008~40.tmd:" + cr + _
				"- 'File name': c:\Documents\LETTER-" + cr + _
				"- First 'from': 2007" + cr + _
				"- First 'to': 2008" + cr + _
				"- Separator: ~" + cr + _
				"- Second 'from': 01" + cr + _
				"- Second 'to': 40"

	' Presets for dialog

	Dlg.FileType = "tmd"

	If Dialog(Dlg) = 0 Then Exit Sub

	' Generate list of files

	elements = 0

	For i = Val(Dlg.Count1_Start) to Val(Dlg.Count1_End)
	   For j = Val(Dlg.Count2_Start) to Val(Dlg.Count2_End)

   	   ' Set text for first counter
      	If Val(Dlg.Count1_Start) = 0 and Val(Dlg.Count1_End) = 0 Then
	         counter1 = ""
   	   else
      	   counter1 = Str(i)
         
	         ' Add leading zeros to first counter
   	      If (Len(Dlg.Count1_End) - Len(counter1)) > 0 Then
      	      counter1 = String(Len(Dlg.Count1_End) - Len(counter1), "0") + counter1
         	End If
	      End If

   	   ' Set text for second counter
      	If Val(Dlg.Count2_Start) = 0 and Val(Dlg.Count2_End) = 0 Then
         	counter2 = ""
	      else
   	      counter2 = Str(j)
         
	         ' Add leading zeros to second counter
   	      If (Len(Dlg.Count2_End) - Len(counter2)) > 0 Then
      	      counter2 = String(Len(Dlg.Count2_End) - Len(counter2), "0") + counter2
         	End If
	      End If

   	   ' Create full name
      	fullName = Dlg.FileName + counter1 + Dlg.Sep1 + counter2 + Dlg.Sep2 + "." + Dlg.FileType

	      ' Add name to listbox
   	   ListBoxElements(elements) = fullName
      
      	If elements < max_files Then
	         elements = elements + 1
   	   Else
      	    Exit For
	      End If
   
	   Next
	Next

	' Show list of files

	If Dialog(Dlg2) = 0 Then Exit Sub

	Set sm = CreateObject("TextMaker.Application")
	sm.activate
	sm.visible = TRUE
        
	' Print the files

	For i = 0 to elements - 1
   	fullName = ListBoxElements(i)
   
	   If Len(fullName) > 0 Then
   	   ' open and print one file in TextMaker
      	sm.Documents.Open fullName
	      sm.ActiveDocument.PrintOut
   	   sm.ActiveDocument.Close
	   End If
	Next

	' Close TextMaker

	sm.Quit
	Set sm = Nothing
End Sub

