Sub TextMakerDemo()

	Dim tm as Object
	Dim x as Object
	Dim i as Integer
	Dim Answer as integer

	' Connect to TextMaker. Launch it if it is not already running
	Set tm = CreateObject("TextMaker.Application")

	' Make TextMaker visible
	tm.Visible = TRUE

	' Maximize TextMaker's application window
	tm.WindowState = tmWindowStateMaximize

	' Focus TextMaker, so that SendKeys goes to the correct window
	tm.Activate 

	' Add an empty document
	tm.Documents.Add

	' Transmit text to TextMaker
	SendKeys "This sentence comes from BasicMaker {Enter}"

	' Better way: use the TypeText method
	With tm.ActiveDocument.Selection
		.TypeText "This sentence also comes from BasicMaker"
		.TypeParagraph
		.TypeText "A new line"
	End With
	
	' Select the first two words
	tm.ActiveDocument.Selection.SetRange 0, 13

	' Change font to Arial 18 pt
	tm.ActiveDocument.Selection.Font.Name = "Arial"
	tm.ActiveDocument.Selection.Font.Size = 18

	' Move text cursor to the right again
	tm.ActiveDocument.Selection.SetRange 0, 0

	' New line
	tm.ActiveDocument.Selection.TypeParagraph

	' Page break
	' MsgBox "A page break will be inserted now", MB_OK or MB_ICONEXCLAMATION, "Information"
	' tm.ActiveDocument.Selection.InsertBreak tmPageBreak

	' Display a message, conditionally exit TextMaker
	Answer = MsgBox("Do you want to exit TextMaker now?", MB_YESNO or MB_ICONQUESTION, "Question")

	if Answer = IDYES then 
	   tm.ActiveDocument.Saved = True ' Clear the "document hasn't been saved yet" flag
	   tm.ActiveDocument.Close
	   tm.Quit ' TextMaker beenden
	else		
	   MsgBox "The document remains open. You can enter text now.", MB_OK or MB_ICONEXCLAMATION, "Hinweis"
	end if	  

	' Cut connection to TextMaker
	Set tm = Nothing
End Sub

